# saga::cpr::checkpoint Class Reference

The saga::replica class implements the saga::attributes interface. More...

`#include <cpr_checkpoint.hpp>`

Inheritance diagram for saga::cpr::checkpoint:

[legend]

List of all members.

## Public Member Functions
| checkpoint (session const &s, saga::url url, int mode=Read)
| Creates the object.
| checkpoint (saga::url url, int mode=Read)
| Creates the object.
| checkpoint (saga::object const &o)
| Creates the object.
| checkpoint (void)
| Creates the object.
| ~checkpoint (void)
| Destroys the object.
checkpoint & | operator= (saga::object const &o)
| Brief description starts here.
void | set_parent (saga::url url, int generation=1)
| set the previous checkpoint url
saga::url | get_parent (int generation=1)
| get the previous checkpoint url
std::vector< saga::url > | list_files (void)
| list the available checkpoint files
int | add_file (saga::url url)
| register a checkpoint file
saga::url | get_file (int id)
| get the url for a specific checkpoint file
saga::filesystem::file | open_file (int id, int flags=CreateParents|Lock|ReadWrite)
| open a specific checkpoint file by id
saga::filesystem::file | open_file (saga::url url, int flags=CreateParents|Lock|ReadWrite)
| open a specific checkpoint file by name
void | remove_file (int id)
| remove a specific checkpoint file by id
void | remove_file (saga::url url)
| remove a specific checkpoint file by name
void | update_file (int id, saga::url new_url)
| update a specific checkpoint file by id
void | update_file (saga::url old_url, saga::url new_url)
| update a specific checkpoint file by name
void | stage_file (int id, saga::url new_url)
| stage a specific checkpoint file by id
void | stage_file (saga::url old_url, saga::url new_url)
| stage a specific checkpoint file by name
void | stage_file (saga::url new_url)
| stage all checkpoint files
## Static Public Member Functions
static checkpoint | create (session const &s, saga::url url, int mode=Read)
| Factory function resembling checkpoint(session, url, int) constructor.
static checkpoint | create (saga::url url, int mode=Read)
| Factory function resembling checkpoint(url, int) constructor.
template<typename Tag>
static saga::task | create (saga::url url, int mode=Read)
| Factory function resembling entry(url, int) constructor.

## Detailed Description

The saga::replica class implements the saga::attributes interface.

A checkpoint represents merely an entry in a name space which has (a) an associated set of registered (physical) checkpoint files of that checkpoint, and (b) an associated set of meta data describing that checkpoint. Both sets can be empty. To access the content of a checkpoint, a saga::file needs to be created with one of the registered file locations.

## Constructor & Destructor Documentation

saga::cpr::checkpoint::checkpoint | ( | session const & | s,
|  | saga::url | url,
|  | int | mode = `Read` |
| ) |  |  |

Creates the object.

References saga::cpr::attributes::cpr_children, saga::cpr::attributes::cpr_mode, saga::cpr::attributes::cpr_nfliles, saga::cpr::attributes::cpr_parent, and saga::cpr::attributes::cpr_time.

saga::cpr::checkpoint::checkpoint | ( | saga::url | url,
|  | int | mode = `Read` |
| ) |  |  | `[explicit]`

Creates the object.

References saga::cpr::attributes::cpr_children, saga::cpr::attributes::cpr_mode, saga::cpr::attributes::cpr_nfliles, saga::cpr::attributes::cpr_parent, and saga::cpr::attributes::cpr_time.

saga::cpr::checkpoint::checkpoint | ( | saga::object const & | o | ) | `[explicit]`

Creates the object.

References saga::BadParameter, saga::object::CPRCheckpoint, and saga::object::get_type().

saga::cpr::checkpoint::checkpoint | ( | void |  | ) |

Creates the object.

saga::cpr::checkpoint::~checkpoint | ( | void |  | ) |

Destroys the object.

## Member Function Documentation

static checkpoint saga::cpr::checkpoint::create | ( | session const & | s,
|  | saga::url | url,
|  | int | mode = `Read` |
| ) |  |  | `[inline, static]`

Factory function resembling checkpoint(session, url, int) constructor.

Reimplemented from saga::name_space::entry.

static checkpoint saga::cpr::checkpoint::create | ( | saga::url | url,
|  | int | mode = `Read` |
| ) |  |  | `[inline, static]`

Factory function resembling checkpoint(url, int) constructor.

Reimplemented from saga::name_space::entry.

template<typename Tag>

static saga::task saga::cpr::checkpoint::create | ( | saga::url | url,
|  | int | mode = `Read` |
| ) |  |  | `[inline, static]`

Factory function resembling entry(url, int) constructor.

Reimplemented from saga::name_space::entry.

checkpoint & saga::cpr::checkpoint::operator= | ( | saga::object const & | o | ) |

Brief description starts here.

Reimplemented from saga::name_space::entry.

References saga::name_space::entry::operator=().

void saga::cpr::checkpoint::set_parent | ( | saga::url | url,
|  | int | generation = `1` |
| ) |  |  | `[inline]`

set the previous checkpoint url

Parameters:

  | generation | number of generations to go backwards

saga::url saga::cpr::checkpoint::get_parent | ( | int | generation = `1` | ) | `[inline]`

get the previous checkpoint url

Parameters:

  | generation | number of generations to go backwards

std::vector<saga::url> saga::cpr::checkpoint::list_files | ( | void |  | ) | `[inline]`

list the available checkpoint files

References saga::task::get_result().

int saga::cpr::checkpoint::add_file | ( | saga::url | url | ) | `[inline]`

register a checkpoint file

Parameters:

  | file | url

References saga::task::get_result().

saga::url saga::cpr::checkpoint::get_file | ( | int | id | ) | `[inline]`

get the url for a specific checkpoint file

Parameters:

  | file | id

References saga::task::get_result().

saga::filesystem::file saga::cpr::checkpoint::open_file | ( | int | id,
|  | int | flags = `CreateParents | Lock | ReadWrite` |
| ) |  |  | `[inline]`

open a specific checkpoint file by id

Parameters:

  | file | id
  | open | flags

References saga::task::get_result().

saga::filesystem::file saga::cpr::checkpoint::open_file | ( | saga::url | url,
|  | int | flags = `CreateParents | Lock | ReadWrite` |
| ) |  |  | `[inline]`

open a specific checkpoint file by name

Parameters:

  | file | url
  | open | flags

References saga::task::get_result().

void saga::cpr::checkpoint::remove_file | ( | int | id | ) | `[inline]`

remove a specific checkpoint file by id

Parameters:

  | checkpoint | url
  | file | id

void saga::cpr::checkpoint::remove_file | ( | saga::url | url | ) | `[inline]`

remove a specific checkpoint file by name

Parameters:

  | file | url

void saga::cpr::checkpoint::update_file | ( | int | id,
|  | saga::url | new_url |
| ) |  |  | `[inline]`

update a specific checkpoint file by id

Parameters:

  | file | id
  | new | url

void saga::cpr::checkpoint::update_file | ( | saga::url | old_url,
|  | saga::url | new_url |
| ) |  |  | `[inline]`

update a specific checkpoint file by name

Parameters:

  | old | url
  | new | url

void saga::cpr::checkpoint::stage_file | ( | int | id,
|  | saga::url | new_url |
| ) |  |  | `[inline]`

stage a specific checkpoint file by id

Parameters:

  | file | id
  | target | url

void saga::cpr::checkpoint::stage_file | ( | saga::url | old_url,
|  | saga::url | new_url |
| ) |  |  | `[inline]`

stage a specific checkpoint file by name

Parameters:

  | source | url
  | target | url

References saga::task::get_result().

void saga::cpr::checkpoint::stage_file | ( | saga::url | new_url | ) | `[inline]`

stage all checkpoint files

Parameters:

  | target | url

The documentation for this class was generated from the following files:

- cpr_checkpoint.hpp
- cpr_checkpoint.cpp